_MainComponentClassName = "Land_ConcretePanels_02_single_v1_F";
_MainComponentPosition = [21967.3,21021.4,24.5424];
ElvtrMainComponentDirection = 132.5;
_ComponentsClassNames = ["Land_ConcretePanels_02_single_v1_F","Land_Shoot_House_Wall_Long_Stand_F","Land_Shoot_House_Wall_Stand_F","Land_Shoot_House_Wall_Stand_F","Land_Shoot_House_Wall_Stand_F","Land_Shoot_House_Wall_Stand_F","Land_Shoot_House_Wall_Stand_F","Land_ConcretePanels_02_single_v1_F","Land_ConcretePanels_02_single_v1_F","Land_Shoot_House_Wall_Stand_F"];
ElvtrComponentsPositions = [[0.6,0,0],[1.5,0,0.24],[0,1.8,0.24],[1,1.8,0.24],[1,-1.8,0.24],[0,-1.8,0.24],[-0.9,-0.7,0.24],[0,0,2.31],[0.6,0,2.31],ElvtrInternalDoorFinalPosition];
ElvtrComponentsRotations = [0,90,0,0,0,0,90,0,0,90];

_CallConsoleObjectName = "Sign_Sphere10cm_Geometry_F";
ElvtrCallConsolePosition = [0.2,1.65,1.2];
_CallConsoleRotation = 0;

//_ExternalDoorClassName_Bottom = "Land_Shoot_House_Wall_Stand_F";
_ExternalDoorClassName_Bottom = "Land_Shoot_House_Wall_F";
//_ExternalDoorClassname_Upper = "Land_Shoot_House_Wall_Crouch_F";
_ExternalDoorDirection = 222.5;
//_ExternalDoorUpperPartPosition = [0.001,0.001,1.9];

ElevatorParts = [];

Elvtr_Floor = _MainComponentClassName createVehicleLocal _MainComponentPosition;
Elvtr_Floor setposasl _MainComponentPosition;
Elvtr_Floor setDir ElvtrMainComponentDirection;

_i = 0;
while {_i < (count _ComponentsClassNames)}do
{
	_CurrentClassName = _ComponentsClassNames select _i;
	_CurrentRelativePosition = ElvtrComponentsPositions select _i;
	_CurrenDirection = ElvtrComponentsRotations select _i;
	_CreatedObject =  _CurrentClassName createVehicleLocal _MainComponentPosition;
	ElevatorParts = ElevatorParts + [_CreatedObject];
	_CreatedObject setDir _CurrenDirection + ElvtrMainComponentDirection;
	_CurrentAbsolutePosition = Elvtr_Floor modelToWorld _CurrentRelativePosition;
	_CreatedObject setpos _CurrentAbsolutePosition;
	_CreatedObject setVectorUp [0,0,1];
	_i = _i + 1;
};


Elvtr_InternalDoor = ElevatorParts select ((count ElevatorParts) - 1);

ElvtrInternalConsole =  _CallConsoleObjectName createVehicleLocal _MainComponentPosition;
ElvtrInternalConsole attachTo [Elvtr_Floor,ElvtrCallConsolePosition];
ElvtrInternalConsole setDir _CallConsoleRotation;

{
	if(isNil "ace_interact_menu_fnc_addActionToObject")then
	{
		ElvtrInternalConsole addAction _x;
	}
	else
	{
		[ElvtrInternalConsole, 0, [], _x] call ace_interact_menu_fnc_addActionToObject;
	};

} forEach ElvtrInternalConsoleOptions;

_Floor = 0;
while {_Floor < (count ElvtrFloorPositions)}do
{//Create local doors
	_PositionForCurrentDoor = ElvtrExternalDoorFinalPosition + [ElvtrFloorPositions select _Floor];
	_NewBottomPart = _ExternalDoorClassName_Bottom createVehicleLocal _PositionForCurrentDoor;
	_NewBottomPart setPosASL _PositionForCurrentDoor;
	_NewBottomPart setDir _ExternalDoorDirection;
	ElvtrExternalDoors set [_Floor,_NewBottomPart];
	_Floor = _Floor + 1;
};