if(!isDedicated)then
{
	ElvtrIsPlayerOnElevatorFloor =
	{
		_Output = false;
		_LocalPosition = Elvtr_Floor worldToModel (getPosATL PLAYER);
		_HeightDiff = (getposASL player select 2) - (getposASL Elvtr_Floor select 2);
		if((_HeightDiff > -1) && (_HeightDiff < 1))then
		{
			_X = _LocalPosition select 0;
			if(_X > (InternalBorders_NegativeLimit select 0) && _X < (InternalBorders_PositiveLimit select 0))then
			{
				_Y = _LocalPosition select 1;
				_Output = _Y > (InternalBorders_NegativeLimit select 1) && _Y < (InternalBorders_PositiveLimit select 1);
			};
		};
		_Output//return
	};
};

if(!isServer)then
{
	_dt_base = 0.01;
	_dt = _dt_base;
	_InternalDoorObject = ElevatorParts select ((count ElevatorParts) - 1);
	_LastSetDoorPosition = -1;
	_LatsTimeCabinPositionChangedFromServer = -1;
	_CurrentHeight = getposASL Elvtr_Floor select 2;
	_LastReceivedCabinPosition = _CurrentHeight;
	while {true}do
	{
		sleep _dt;
		_CurrentHeight = getposASL Elvtr_Floor select 2;
		if(_LastReceivedCabinPosition != ElevatorHeight)then
		{//New update from server
			Elvtr_Floor setposASL [getposASL Elvtr_Floor select 0,getposASL Elvtr_Floor select 1,ElevatorHeight];
			_LastReceivedCabinPosition = ElevatorHeight;
			[] call  ElvtrRefreshPartPositions;
			_LatsTimeCabinPositionChangedFromServer = time;
		};

		if(abs(ElvtrCurrentSpeed) > 0.001)then
		{//Elevator cabin has speed
			_TimeSincLastUpdate = time - _LatsTimeCabinPositionChangedFromServer;
			if((_TimeSincLastUpdate > 0.01) && (_TimeSincLastUpdate < 1))then
			{//Last update was reasonable time ago so it could be assumed that cabin is til on move
				_ExtrapolatedHeigt = _LastReceivedCabinPosition + _TimeSincLastUpdate*ElvtrCurrentSpeed;
				Elvtr_Floor setposASL [getposASL Elvtr_Floor select 0,getposASL Elvtr_Floor select 1,ElevatorHeight];
				[] call  ElvtrRefreshPartPositions;
			};
			if(call ElvtrIsPlayerOnElevatorFloor)then
			{
					player setVelocity [0,0,ElvtrPlayerDownSpeed + (ElvtrCurrentSpeed/2)];
			};
		}
		else
		{//Elevator cabin is not moving

			if(_LastSetDoorPosition != ElvtrDoorPosition)then
			{
				_TargetDoorPosition = (ElvtrInternalDoorFinalPosition vectorMultiply ElvtrDoorPosition) vectorAdd (ElvtrInternalDoorStartPosition vectorMultiply (1-ElvtrDoorPosition));
				_TargetDoorPosition = Elvtr_Floor modelToWorld _TargetDoorPosition;
				_InternalDoorASL = getposASL _InternalDoorObject select 2;
				_TargetDoorPosition set [2,_InternalDoorASL];
				_InternalDoorObject setPosASL _TargetDoorPosition;

				_DoorAtCurrentFloor = ElvtrExternalDoors select ElvtrCurrentFloor;
				_ExternalStart = ElvtrExternalDoorStartPosition + [ElvtrFloorPositions select ElvtrCurrentFloor];
				_ExternalFinish = ElvtrExternalDoorFinalPosition + [ElvtrFloorPositions select ElvtrCurrentFloor];
				_TargetExternalDoorPosition = (_ExternalFinish vectorMultiply ElvtrDoorPosition) vectorAdd (_ExternalStart vectorMultiply (1-ElvtrDoorPosition));
				_DoorAtCurrentFloor setPosASL _TargetExternalDoorPosition;
				_LastSetDoorPosition = ElvtrDoorPosition;
			};
		};
		_dt = _dt_base + 0.01* (player distance Elvtr_Floor);
	};
};